unit UnidadMenuPrincipal;

{$R WinXP.res}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, stdCtrls, Buttons, ComCtrls, ExtCtrls, shellapi, pngimage,
  ThemeMgr;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    txtPNG: TEdit;
    btObtenerMeta: TBitBtn;
    meDatos: TMemo;
    lsMetas: TListBox;
    dlAbrir: TOpenDialog;
    btSel: TBitBtn;
    StaticText1: TStaticText;
    Label2: TLabel;
    StaticText2: TStaticText;
    Label3: TLabel;
    ThemeManager1: TThemeManager;
    Shape1: TShape;
    Shape2: TShape;
    LWEB: TLabel;
    procedure btObtenerMetaClick(Sender: TObject);
    procedure btSelClick(Sender: TObject);
    procedure lsMetasClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    //declaramos el objeto PNG
    png: TPngObject;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{Al crear el formulario, creamos el objeto PNG}
constructor TForm1.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  png := tpngobject.create;
end;

{Al destruir el formulario, destruimos el objeto PNG}
destructor TForm1.Destroy; 
begin
  inherited Destroy;  
  png.free;
end;


procedure TForm1.btObtenerMetaClick(Sender: TObject);
var
  i: Integer;
begin
  try
    //cargamos el fichero png seleccionado
    png.LoadFromFile(txtPNG.Text);

    lsMetas.items.clear;
    //buscamos los metadatos de tipo EXt
    for i := 0 to png.chunks.count - 1 do
      if png.chunks.item[i] is TChunktEXt then
        lsMetas.Items.AddObject(
            TChunktEXt(png.chunks.item[i]).keyword, png.chunks.item[i]);
  except
    messagedlg ('El fichero PNG seleccionado no ha podido ser ledo.',
        mtwarning, [mbok], 0);
  end;

end;

procedure TForm1.btSelClick(Sender: TObject);
begin
  if dlAbrir.Execute then
    txtPNG.Text := dlAbrir.FileName;
end;

procedure TForm1.lsMetasClick(Sender: TObject);
begin
  if lsMetas.itemindex <> -1 then
    meDatos.text :=
        TChunktEXt(lsMetas.Items.Objects[lsMetas.itemindex]).Text;
end;

procedure TForm1.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
